#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_convert_to_error4xi.py">
#<abstract4xi abstract = "tests convert_to_error4xi"/>
#<verify4xi verification = "10" target = "convert_to_error4xi.py"/>
#<contextualize4xi context = "listener_client4xi.py; array4xi.py; syncmanager4xi.py; token4xi.py; server4xi.py; manager4xi.py; authenticationstring4xi.py; popen4xi.py; lock4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'test_convert_to_error4xi' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading
import _winapi
import array

# -------------------------------------------------------------------------------------------------
# conditional imports                              
# -------------------------------------------------------------------------------------------------
try:
    from cPickle import PicklingError
except ImportError:
    from pickle import PicklingError
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from array4xi import Array4Xi
from authenticationstring4xi import AuthenticationString4Xi

from convert_to_error4xi import convert_to_error4xi
from client4xi import Client4Xi

from listener4xi import Listener4Xi
from listener_client4xi import listener_client4xi
from lock4xi import Lock4Xi

from manager4xi import Manager4Xi

from pickle4xi import pickle4xi
from popen4xi import Popen4Xi

from syncmanager4xi import SyncManager4Xi
from server4xi import Server4Xi

from token4xi import Token4Xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

#" 
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)  ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)  ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    __all__ = [ 'convert_to_error4xi'] 
    
    KB4Tailoring = {
        'Client4Xi': 'NACK4TRACE',               # OK
        'convert_to_error4xi': 'NACK4TRACE',     # OK
        'listener_client4xi': 'NACK4TRACE',      # OK
        'Array4Xi': 'NACK4TRACE',                # OK
        'SyncManager4Xi': 'NACK4TRACE',          # OK
        'Token4Xi': 'NACK4TRACE',                # OK
        'Server4Xi': 'NACK4TRACE',               # OK
        'Manager4Xi': 'NACK4TRACE',              # OK
        'pickle4xi': 'NACK4TRACE',               # OK
        'AuthenticationString4Xi': 'NACK4TRACE', # OK
        'Popen4Xi': 'NACK4TRACE',                # OK
        'Listener4Xi': 'NACK4TRACE',             # OK
        'Lock4Xi': 'NACK4TRACE'                  # OK
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Array4Xi
        # AuthenticationString4Xi
        # Lock4Xi
        # Manager4Xi
        # Popen4Xi
        # Server4Xi
        # SyncManager4Xi
        # Token4Xi
        # convert_to_error4xi
        # listener_client4xi
        # pickle4xi
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING:  ", time4xi())
    #

    
#</function4xi>       

             
            
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   creates XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(p2xi):
  

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
    
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-convert-to-error4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing converting errors in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for converting errors.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(p2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-convert-to-error4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for converting errors in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations converting errors in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
    xml_trace_reason4xi(p2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-convert-to-error4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for converting errors in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for converting errors in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(p2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       

# -------------------------------------------------------------------------------------------------
#<function4xi function = "func2xi" usage = "
#   Python functions can have keyword-only arguments listed after the * parameter and before the ** paramter if any, e.g.
#   def f(a, b, *args, c, d = 42, e, **kwds):
#                 e c, d and e cannot be passed as position arguments and must be passed as keyword arguments
#                 c and e are required keyword arguments, since they do not have a default value
#   if the parameter name after the * is omitted, the function will not accept any extra positional arguments
#   def g(a, b, *, c, d): ...takes exactly two positional parameters and has two required keyword parameters
#   
#">                       
# -------------------------------------------------------------------------------------------------  
def func2xi(token, serializer, incref, **kwds):

    return True

#</function4xi>     


# -------------------------------------------------------------------------------------------------
#<function4xi function = "test" usage = "
#   test
# -------------------------------------------------------------------------------------------------    
def test(obj):
    
    # ---------------------------------------------------------------------------------------------
    # Information about the module
    # ---------------------------------------------------------------------------------------------
    print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ", time4xi())
    print("\n test_convert_to_error4xi ", time4xi())
    
    # ---------------------------------------------------------------------------------------------
    # All methods of this object
    # ---------------------------------------------------------------------------------------------
    print("\n convert_to_error4xi all methods: ", all_methods4xi(obj))
   

    # ---------------------------------------------------------------------------------------------
    # Methods compatible with multiprocessing
    # ---------------------------------------------------------------------------------------------
    #print("\n : ", obj.()) <--- copy and paste to test the methods returning something
    

    
    
    # ---------------------------------------------------------------------------------------------
    # Methods added by DragonXi
    # ---------------------------------------------------------------------------------------------
    print("\n sense: ", obj.sense())
    print("\n reason: ", obj.reason())
    print("\n ace: ", obj.ace())

    # ---------------------------------------------------------------------------------------------
    # End of test
    # ---------------------------------------------------------------------------------------------
    print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ", time4xi())

#</function4xi>    
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_convert_to_errors4xi" usage = "
#   testing converting errors
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def test_convert_to_errors4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0/33) OF TEST_CONVERT_TO_ERRORS4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:    

        # ---------------------------------------------------------------------------------------------
        # (STEP 1/9) - CREATE TOKEN 
        # --------------------------------------------------------------------------------------------- 
      
        typeid2xi = "ip"
        address2xi = ('localhost', 8080)
        id2xi = "yourdragonxi.com"
        
        ack2token = False
        nack2token = True
        
        print('=' *33)
        print("(STEP 1/9a) OF TEST_CONVERT_TO_ERRORS4XI - CREATING TOKEN ", time4xi())
        print('=' *33)
        # 02:43:39 02/12/13 Pacific Standard Time
        try:    
            token2xi = Token4Xi(typeid2xi, address2xi, id2xi)
        
            print('=' *33)
            print("(STEP 1/9b) OF TEST_CONVERT_TO_ERRORS4XI - CREATED TOKEN: ", token2xi)
            print('=' *33)
            # { Token4Xi : __init__ ; shared; slots-shared-by-token2xi-of-Token4Xi: ('typeid', 'address', 'id'); time: 02:43:39 02/12/13 Pacific Standard Time}
            # { Token4Xi : __repr__ ; returning; typeid-address-id-of-token2xi-returning-by-repr-of-Token4Xi: ('ip', ('localhost', 8080), 'yourdragonxi.com'); time: 02:43:39 02/12/13 Pacific Standard Time}  
            # Token4Xi(typeid='ip', address=('localhost', 8080), id='yourdragonxi.com')
            nack2token = False
            ack2token = True
                    
        except:
         
            print('=' *33)
            print("(STEP 1/9z) OF TEST_CONVERT_TO_ERRORS4XI *** FAILED TO CREATE TOKEN *** ", time4xi())
            print('=' *33)
            
        # ---------------------------------------------------------------------------------------------
        # (STEP 2/9) - CREATE SERVER 
        # ---------------------------------------------------------------------------------------------
        registry2xi =  {}
        authkey2xi = os.urandom(32)
        serializer2xi='pickle'
        
        ack2server = False
        nack2server = True    
        
        print('=' *33)
        print("(STEP 2/9a) OF TEST_CONVERT_TO_ERRORS4XI - CREATING SERVER ", time4xi()) 
        print('=' *33)
        # 02:43:39 02/12/13 Pacific Standard Time        
        try:    
        
            server2xi = Server4Xi(registry2xi, address2xi, authkey2xi, serializer2xi)
            
        
            print('=' *33)
            print("(STEP 2/9b) OF TEST_CONVERT_TO_ERRORS4XI - CREATED SERVER: ", server2xi)
            print('=' *33)
            # <server4xi.Server4Xi object at 0x0000000002B78780> <-- due to trace      
            nack2server = False
            ack2server = True        
        except:
         
            print('=' *33)
            print("(STEP 2/9z) OF TEST_CONVERT_TO_ERRORS4XI *** FAILED TO CREATE SERVER ***  ", time4xi())
            print('=' *33)        
            
        # ---------------------------------------------------------------------------------------------
        # (STEP 3/9)- CREATE MANAGER
        # ---------------------------------------------------------------------------------------------
        ack2manager = False
        nack2manager = True    
        
        print('=' *33)
        print("(STEP 3/9a) OF TEST_CONVERT_TO_ERRORS4XI - CREATING MANAGER ", time4xi())
        print('=' *33)
        # 02:43:39 02/12/13 Pacific Standard Time        
        try:    
            manager2xi = Manager4Xi()
        
            print('=' *33)
            print("(STEP 3/9b) OF TEST_CONVERT_TO_ERRORS4XI - CREATED MANAGER: ", manager2xi)
            print('=' *33)
            # <multiprocessing.managers.SyncManager object at 0x00000000039A3A20>
            nack2manager = False
            ack2manager = True 
        except:
         
            print('=' *33)
            print("(STEP 3/9z) OF TEST_CONVERT_TO_ERRORS4XI *** FAILED TO CREATE MANAGER ***  ", time4xi())
            print('=' *33)        
                               
        # ---------------------------------------------------------------------------------------------
        # (STEP 4/9)- CREATE LOCK
        # ---------------------------------------------------------------------------------------------
        
        exposed2xi=('sense', 'reason', 'ace')
        incref2xi=True
        cache2xi={}
        s2xi = 'AutoProxyXi'
        name2xi = 'AutoProxy[%s2xi]'
        
        print('=' *33)
        print("(STEP 4/9a) OF TEST_CONVERT_TO_ERRORS4XI - CREATING LOCK ", time4xi())
        print('=' *33)
        # 02:43:39 02/12/13 Pacific Standard Time        
        try:    
                
            lock2xi = Lock4Xi()
        
            print('=' *33)
            print("(STEP 4/9b) OF TEST_CONVERT_TO_ERRORS4XI - CREATED LOCK: ", lock2xi)
            print('=' *33)
            # <Lock(owner=None)>
        except:
         
            print('=' *33)
            print("(STEP 4/9z) OF TEST_CONVERT_TO_ERRORS4XI *** FAILED TO CREATE LOCK ***  ", time4xi())
            print('=' *33)        
                               
                               
        # ---------------------------------------------------------------------------------------------
        # (STEP 5/9) - CREATE ARRAY
        # ---------------------------------------------------------------------------------------------
         
        # ---------------------------------------------------------------------------------------------
        # Array
        # Type code C Type Python Type Minimum size in bytes 
        # 'c' char character 1 
        # 'b' signed char int 1 
        # 'B' unsigned char int 1 
        # 'u' Py_UNICODE Unicode character 2 
        # 'h' signed short int 2 
        # 'H' unsigned short int 2 
        # 'i' signed int int 2 
        # 'I' unsigned int long 2 
        # 'l' signed long int 4 
        # 'L' unsigned long long 4 
        # 'f' float float 4 
        # 'd' double float 8 
        # ---------------------------------------------------------------------------------------------
        typecode2xi = 'u'
        sequence2xi = []
        
        # ---------------------------------------------------------------------------------------------
        # building keywords
        # ---------------------------------------------------------------------------------------------
        kwds2xi = {}
        #kwds2xi['authkey'] = authkey2xi
        kwds2xi['incref'] = True
    
        # ---------------------------------------------------------------------------------------------
        #
        # ---------------------------------------------------------------------------------------------    
        au = "\N{GREEK CAPITAL LETTER DELTA}"  
        bu = "\u0394"
        cu = "\U00000394"
        creekarray2xi = [au, bu, cu]
        
    
        sequence2xi = creekarray2xi
        
        print('=' *33)
        print("(STEP 5/9a) OF TEST_CONVERT_TO_ERRORS4XI - CREATING ARRAY ", time4xi())
        print('=' *33)
        # 02:43:39 02/12/13 Pacific Standard Time       
        try:    
                
            xi2a = Array4Xi(typecode2xi, sequence2xi, lock2xi)
        
            #print('=' *33)
            #print("(STEP 5/9b) CREATED ARRAY:  ", time4xi())
            #print(xi2a)
            #print('=' *33)
        except:
         
            print('=' *33)
            print("(STEP 5/9z) OF TEST_CONVERT_TO_ERRORS4XI *** FAILED TO CREATE ARRAY ***  ", time4xi())
            print('=' *33)        
                 
             
        # ---------------------------------------------------------------------------------------------
        # (STEP 6/9)- CREATE LISTENER
        # ---------------------------------------------------------------------------------------------
        ack2listener = False
        nack2listener = True  
    
        ack2client = False          
        nack2client = True  
        
           
        print('=' *33)
        print("(STEP 6/9a) OF TEST_CONVERT_TO_ERRORS4XI - CREATING LISTENER AND CLIENT ", time4xi())
        print('=' *33) 
        # 02:43:39 02/12/13 Pacific Standard Time        
        try:
            listener2xi, client2xi = listener_client4xi[serializer2xi]
         
            print('=' *33)
            print("(STEP 6/9b) OF TEST_CONVERT_TO_ERRORS4XI - CREATED LISTENER: ", listener2xi)
            print('=' *33)
            # <class 'listener4xi.Listener4Xi'>
            print('=' *33)
            print("(STEP 6/9b) OF TEST_CONVERT_TO_ERRORS4XI - CREATED CLIENT: ", client2xi)
            print('=' *33)
            # <function Client4Xi at 0x0000000003214620>
            nack2listener = False
            ack2listener = True  
    
            nack2client = False          
            ack2client = True                   
    
        except:
         
            print('=' *33)
            print("(STEP 6/9C) OF TEST_CONVERT_TO_ERRORS4XI *** FAILED TO CREATE LISTENER AND CLIENT ", time4xi())
            print('=' *33)
               
        # ---------------------------------------------------------------------------------------------
        # (STEP 7/9) - CREATE CONNECTION 
        # ---------------------------------------------------------------------------------------------
            
        ack2connection = False
        nack2connection = True  
               
        print('=' *33) 
        print("(STEP 7/9a1) OF TEST_CONVERT_TO_ERRORS4XI - CREATING CONNECTION BY CALLING CLIENT ", client2xi) 
        # <function Client4Xi at 0x000000000354F158> 
        print("(STEP 7/9a2) OF TEST_CONVERT_TO_ERRORS4XI - CREATING CONNECTION BY PASSING ADDRESS ", address2xi)
        # ('localhost', 8080)
        print("(STEP 7/9a3) OF TEST_CONVERT_TO_ERRORS4XI - CREATING CONNECTION BY PASSING AUTHKEY ", authkey2xi) 
        # b'\x99\xa2/\x88*\x1a\x84\xf9\x80\xf8\x9c\xa4\x91r5[b\x0f\x10E!\xd0\xb6\xf9\x90Yq\x8a\xcc\x0f\xca\x04'
        print('=' *33)
        # <function Client4Xi at 0x000000000340CF28>        
        try: 
            # pass           
            connection2xi = client2xi(address2xi, authkey2xi)
               
            print('=' *33)
            print("(STEP 7/9b) OF TEST_CONVERT_TO_ERRORS4XI - CREATED CONNECTION: ", connection2xi)
            print('=' *33)
               
            nack2connection = False
            ack2connection = True  
    
        except:
         
            print('=' *33)
            print("(STEP 7/9C) OF TEST_CONVERT_TO_ERRORS4XI *** FAILED TO CREATE CONNECTION ", time4xi())
            
            print('=' *33)
               
        # ---------------------------------------------------------------------------------------------
        # (STEP 8/9) - CONVERT_TO_ERRORS
        # ---------------------------------------------------------------------------------------------
        ack2response = False
        nack2response = True  
       
        if ack2connection is True: 
        
                   
            print('=' *33)
            print("(STEP 8/9a) OF TEST_CONVERT_TO_ERRORS4XI - RECEIVING  ", time4xi())
            print('=' *33)
                    
            try:            
                            
                kind2xi, result2xi = connection2xi.recv()
                       
                print('=' *33)
                print("(STEP 8/9b) OF TEST_CONVERT_TO_ERRORS4XI - RECEIVED KIND2XI: ", kind2xi)
                print('=' *33)
                       
                print('=' *33)
                print("(STEP 8/9c) OF TEST_CONVERT_TO_ERRORS4XI - RECEIVED RESULT2XI: ", result2xi)
                print('=' *33)
                     
                nack2response = False
                ack2response = True  
        
            except:
             
                print('=' *33)
                print("(STEP 8/9Z) OF TEST_CONVERT_TO_ERRORS4XI *** FAILED TO RECEIVE ***  ", time4xi())
                print('=' *33)
        else:
            print('=' *33)
            print("(STEP 8/9E) OF TEST_CONVERT_TO_ERRORS4XI *** SKIPPED RECEIVING - NO CONNECTION ESTABLISHED ***  ", time4xi())
            print('=' *33)                   
        # ---------------------------------------------------------------------------------------------
        # (STEP 9/9)- CONVERT TO ERROR
        # ---------------------------------------------------------------------------------------------
    
        if ack2response is True:  
                   
            print('=' *33)
            print("(STEP 9/9a) OF TEST_CONVERT_TO_ERRORS4XI - CONVERTING TO ERROR ", time4xi())
            print('=' *33)
                
            try:            
                                    
                convert_to_error4xi(kind2xi, result2xi)
    
                   
                print('=' *33)
                print("(STEP 9/9b) OF TEST_CONVERT_TO_ERRORS4XI - CONVERTED TO ERROR ", time4xi())
                print('=' *33)
    
            except:
         
                print('=' *33)
                print("(STEP 9/9z) OF TEST_CONVERT_TO_ERRORS4XI *** FAILED TO CONVERT TO ERROR ***  ", time4xi())
                print('=' *33)
                       
        else:
            print('=' *33)
            print("(STEP 9/9d) OF TEST_CONVERT_TO_ERRORS4XI ** SKIPPED CONVERTING - NO RESPONSE **  ", time4xi())
            print('=' *33)
        
    # -----------------------------------------------------------------------------------------    
    # 
    # ----------------------------------------------------------------------------------------- 
    except:
        print("(Step 7Z/33) OF TEST_CONVERT_TO_ERROR4XI *** FAILED TESTING CONVERT_TO_ERROR4XI ***  ", time4xi())  
        

    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print("(Step 8A/33) OF TEST_CONVERT_TO_ERROR4XISTEP - PASSING TO PRINT_TRACE4XI TRACE OBJECT: ", t2xi)        
        # <print4xi.Print4Xi object at 0x0000000002A2AF28>
        
        print_trace4xi(t2xi)        
           
        # ---------------------------------------------------------------------------------------------    
        # 
        # ---------------------------------------------------------------------------------------------         
        print("(Step 8B/33) OF TEST_CONVERT_TO_ERROR4XISTEP - COMPLETED TESTING CONVERT_TO_ERROR4XI!   ", time4xi())               
        # 
#</function4xi>        
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function to test converting errors
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def main():

    print('=' *33)
    print("STEP: SENSING CONVERTING ERRORS WITH YOURDRAGONXI!  ", time4xi())  
    print('=' *33)
    # 
        
    test_convert_to_errors4xi()  
    
    print('=' *33)
    print("STEP: SENSED CONVERTING ERRORS WITH YOURDRAGONXI!  ", time4xi())    
    print('=' *33) 
    # 
                      
#</function4xi>

    
   
# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()    
    
                             
# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
    
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_convert_to_error4xi.txt

#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_convert_to_error4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

